import axios from "axios";
import { hasKey } from "@utils";

class API {
  constructor(config) {
    this.instance = axios.create(
      Object.assign(
        {
          baseURL: "http://localhost:8080",
          // auth: {
          //   username: "Development",
          //   password: "dev_password",
          // },
          headers: {
            common: {
              Authorization: `Basic ${localStorage.authtoken}`,
            },
          },
        },
        config,
      ),
    );
    this.instance.interceptors.response.use(
      (response) => this.responseSuccessInterceptor(response),
      (error) => this.responseErrorInterceptor(error),
    );
    this.eventCallbacks = {
      successIssue: () => {},
      successPrompt: () => {},
      responseError: () => {},
      authError: () => {},
      noResponseError: () => {},
      beforeRequestError: () => {},
    };
  }

  on(eventName, eventCallback) {
    // ToDo: check correct args types
    this.eventCallbacks[eventName] = eventCallback;
  }

  onEvent(event, payload) {
    if (hasKey(this.eventCallbacks, event)) {
      try {
        this.eventCallbacks[event](payload);
      } catch (error) {
        console.error("API onEvent error", error);
      }
    }
  }

  // Note: any status code that lie within the range of 2xx cause this function to trigger
  responseSuccessInterceptor(response) {
    // [ "InvalidError", "ValidationError", "DuplicateError", "SyntaxError", "OutdatedError", "ForbiddenError", "ConnectionError", "NotFoundError" ];
    if (hasKey(response, "data.issues")) {
      const issues = response.data.issues;
      issues.forEach((issue) => {
        this.onEvent("successIssue", issue);
      });
    }
    if (hasKey(response, "data.prompt")) {
      this.onEvent("successPrompt", response.data.prompt);
    }
    return response;
  }

  // Note: interceptor gets called for every response outside range 2xx
  responseErrorInterceptor(error) {
    if (error.response) {
      if (error.response.status === 401) {
        this.onEvent("authError", error);
      } else {
        this.onEvent("responseError", error);
      }
    } else if (error.request) {
      this.onEvent("noResponseError", error);
    } else {
      this.onEvent("beforeRequestError", error);
    }
    return Promise.reject(error);
  }

  checkCredentials(token) {
    // TODO: replace with token returned from api. Atm: uses Basic Auth pseudotoken like Basic Auth Header would contain.
    this.setCredentials(token);
    return this.getGames()
      .then(() => {
        return true;
      })
      .catch((error) => {
        if (error?.response?.status == 401) {
          return false;
        } else {
          return Promise.reject(error);
        }
      });
  }

  setCredentials(token) {
    this.instance.defaults.headers.common.Authorization = `Basic ${token}`;
  }

  removeCredentials() {
    this.instance.defaults.headers.common.Authorization = undefined;
  }

  get(path) {
    return this.instance
      .get(path)
      .then((response) => response)
      .catch((error) => Promise.reject(error));
  }

  post(path, requestBody) {
    return this.instance
      .post(path, requestBody)
      .then((response) => response)
      .catch((error) => Promise.reject(error));
  }

  put(path, requestBody) {
    return this.instance
      .put(path, requestBody)
      .then((response) => response)
      .catch((error) => Promise.reject(error));
  }

  delete(path) {
    return this.instance
      .delete(path)
      .then((response) => response)
      .catch((error) => Promise.reject(error));
  }

  // Note: generated by adaptor_ex_api_builder
  getConfig() {
    return this.get(`/config`);
  }
  getPlugins() {
    return this.get(`/plugins`);
  }
  getUser() {
    return this.get(`/user`);
  }
  createUser(requestBody) {
    return this.post(`/user`, requestBody);
  }
  getMe() {
    return this.get(`/me`);
  }
  updateMe(requestBody) {
    return this.put(`/me`, requestBody);
  }
  getGames() {
    return this.get(`/games`);
  }
  createGame(requestBody) {
    return this.post(`/game`, requestBody);
  }
  getGame({ game }) {
    return this.get(`/game/${game}`);
  }
  deleteGame({ game }) {
    return this.delete(`/game/${game}`);
  }
  editGameSetup({ game }, requestBody) {
    return this.post(`/game/${game}/setup`, requestBody);
  }
  getMedia({ game }) {
    return this.get(`/game/${game}/media`);
  }
  createLevel({ game }, requestBody) {
    return this.post(`/game/${game}/level`, requestBody);
  }
  findLevel({ game }) {
    return this.get(`/game/${game}/level`);
  }
  getLevel({ game, level }) {
    return this.get(`/game/${game}/level/${level}`);
  }
  updateLevel({ game, level }, requestBody) {
    return this.put(`/game/${game}/level/${level}`, requestBody);
  }
  deleteLevel({ game, level }) {
    return this.delete(`/game/${game}/level/${level}`);
  }
  editLevel({ game, level, operator }, requestBody) {
    return this.post(`/game/${game}/level/${level}/${operator}`, requestBody);
  }
  getLevelVariables({ game, level }) {
    return this.get(`/game/${game}/level/${level}/variables`);
  }
  createState({ game, level }, requestBody) {
    return this.post(`/game/${game}/level/${level}/state`, requestBody);
  }
  updateState({ game, level, state }, requestBody) {
    return this.put(`/game/${game}/level/${level}/state/${state}`, requestBody);
  }
  deleteState({ game, level, state }) {
    return this.delete(`/game/${game}/level/${level}/state/${state}`);
  }
  getLevelSchema({ game }) {
    return this.get(`/game/${game}/level_schema`);
  }
  getActions({ game }) {
    return this.get(`/game/${game}/actions`);
  }
  launchSession({ game }, requestBody) {
    return this.post(`/game/${game}/session`, requestBody);
  }
  findSessions({ game }) {
    return this.get(`/game/${game}/session`);
  }
  getSession({ game, session }) {
    return this.get(`/game/${game}/session/${session}`);
  }
  cancelSession({ game, session }) {
    return this.delete(`/game/${game}/session/${session}`);
  }
  next({ game, session }, requestBody) {
    return this.post(`/game/${game}/session/${session}/_next`, requestBody);
  }
  addPlugin({ game }, requestBody) {
    return this.post(`/game/${game}/plugin`, requestBody);
  }
  findPlugins({ game }) {
    return this.get(`/game/${game}/plugin`);
  }
  getPlugin({ game, plugin }) {
    return this.get(`/game/${game}/plugin/${plugin}`);
  }
  removePlugin({ game, plugin }) {
    return this.delete(`/game/${game}/plugin/${plugin}`);
  }
  updatePluginSettings({ game, plugin }, requestBody) {
    return this.put(`/game/${game}/plugin/${plugin}/settings`, requestBody);
  }
  loadPlugin({ game, plugin }, requestBody) {
    return this.post(`/game/${game}/plugin/${plugin}/_load`, requestBody);
  }
  connectPlugin({ game, plugin }, requestBody) {
    return this.post(`/game/${game}/plugin/${plugin}/_connect`, requestBody);
  }
  disconnectPlugin({ game, plugin }, requestBody) {
    return this.post(`/game/${game}/plugin/${plugin}/_disconnect`, requestBody);
  }
  createPluginItem({ game, plugin, plugin_collection }, requestBody) {
    return this.post(`/game/${game}/plugin/${plugin}/${plugin_collection}`, requestBody);
  }
  findPluginItems({ game, plugin, plugin_collection }) {
    return this.get(`/game/${game}/plugin/${plugin}/${plugin_collection}`);
  }
  getPluginItem({ game, plugin, plugin_collection, item }) {
    return this.get(`/game/${game}/plugin/${plugin}/${plugin_collection}/${item}`);
  }
  deletePluginItem({ game, plugin, plugin_collection, item }) {
    return this.delete(`/game/${game}/plugin/${plugin}/${plugin_collection}/${item}`);
  }
  editPluginItem({ game, plugin, plugin_collection, item }, requestBody) {
    return this.post(`/game/${game}/plugin/${plugin}/${plugin_collection}/${item}/_set`, requestBody);
  }
  connectPluginItem({ game, plugin, plugin_collection, item }, requestBody) {
    return this.post(`/game/${game}/plugin/${plugin}/${plugin_collection}/${item}/_connect`, requestBody);
  }
  disconnectPluginItem({ game, plugin, plugin_collection, item }, requestBody) {
    return this.post(`/game/${game}/plugin/${plugin}/${plugin_collection}/${item}/_disconnect`, requestBody);
  }
  loadPluginItem({ game, plugin, plugin_collection, item }, requestBody) {
    return this.post(`/game/${game}/plugin/${plugin}/${plugin_collection}/${item}/_load`, requestBody);
  }
  getCollections({ game }) {
    return this.get(`/game/${game}/collections`);
  }
  createCollection({ game }, requestBody) {
    return this.post(`/game/${game}/collection`, requestBody);
  }
  createDocument({ game, collection }, requestBody) {
    return this.post(`/game/${game}/collection/${collection}`, requestBody);
  }
  findDocuments({ game, collection }) {
    return this.get(`/game/${game}/collection/${collection}`);
  }
  deleteCollection({ game, collection }) {
    return this.delete(`/game/${game}/collection/${collection}`);
  }
  getDocument({ game, collection, document }) {
    return this.get(`/game/${game}/collection/${collection}/${document}`);
  }
  updateDocument({ game, collection, document }, requestBody) {
    return this.put(`/game/${game}/collection/${collection}/${document}`, requestBody);
  }
  deleteDocument({ game, collection, document }) {
    return this.delete(`/game/${game}/collection/${collection}/${document}`);
  }
  editDocument({ game, collection, document, operator }, requestBody) {
    return this.post(`/game/${game}/collection/${collection}/${document}/${operator}`, requestBody);
  }
  findItems({ game }) {
    return this.get(`/game/${game}/items`);
  }
}

export default API;

/*
api: Object { getClient: getClient(), init: init(), initSync: initSync(), … }
defaults: Object { baseURL: "https://adaptordev.machinaex.org/api", timeout: 0, withCredentials: true, … }
delete: function wrap()
get: function wrap()
head: function wrap()
interceptors: Object { request: {…}, response: {…} }
length: 0
name: "wrap"
options: function wrap()
patch: function wrap()
paths: Object { "/config": {…}, "/plugins": {…}, "/user": {…}, … }
post: function wrap()
prototype: Object { … }
put: function wrap()
request: function wrap()
getUri: function wrap()
*/
